﻿using C1.WPF;
using System;
using System.Collections.Generic;
using System.Data.SqlTypes;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TreeViewEditNode
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            treeView.PreviewKeyDown += TreeView_PreviewKeyDown;
        }

        private void TreeView_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            //if edit mode
            if (e.OriginalSource is TextBox tb && e.Source is C1TreeViewItem)
            {
                //if left key
                if (e.Key == Key.Left)
                {
                    //handle key
                    e.Handled = true;

                    //update textbox cursor position
                    if (tb.SelectionStart == 0)
                    {
                        tb.SelectionStart = 0;
                        tb.SelectionLength = 0;
                    }
                    else
                    {
                        tb.SelectionStart -= 1;
                        tb.SelectionLength = 0;
                    }
                }
                //if right key
                else if (e.Key == Key.Right)
                {
                    //handle key
                    e.Handled = true;

                    //update textbox cursor position
                    tb.SelectionStart += 1;
                    tb.SelectionLength = 0;
                }
            }
        }

        private void treeView_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            if (sender is C1TreeView tree)
            {
                var val = tree.GetNode(e.GetPosition(this));
                tree.StartEditing(val);
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            treeView.StartEditing(treeView.SelectedItem);
        }
    }
}
